(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('micro-dash')) :
    typeof define === 'function' && define.amd ? define('s-js-utils', ['exports', 'micro-dash'], factory) :
    (global = global || self, factory(global['s-js-utils'] = {}, global.microDash));
}(this, (function (exports, microDash) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __exportStar(m, exports) {
        for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m) return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    /**
     * Returns whether `set` contains all the elements in `subset`. Taken from https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Set.
     *
     * ```ts
     * const setA = new Set([1, 2, 3, 4]);
     * const setB = new Set([3, 4]);
     * setUnion(setA, setB); // true
     * ```
     */
    function isSuperset(set, subset) {
        var e_1, _a;
        try {
            for (var subset_1 = __values(subset), subset_1_1 = subset_1.next(); !subset_1_1.done; subset_1_1 = subset_1.next()) {
                var elem = subset_1_1.value;
                if (!set.has(elem)) {
                    return false;
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (subset_1_1 && !subset_1_1.done && (_a = subset_1.return)) _a.call(subset_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return true;
    }

    function isSetEqual(setA, setB) {
        return setA.size === setB.size && isSuperset(setA, setB);
    }

    /**
     * Returns a new set that contains the elements of `setA` that are not in `setB`. Taken from https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Set.
     *
     * ```ts
     * const setA = new Set([1, 2, 3, 4]);
     * const setB = new Set([3, 4, 5, 6]);
     * setDifference(setA, setB); // Set [1, 2]
     * ```
     */
    function setDifference(setA, setB) {
        var e_1, _a;
        var difference = new Set(setA);
        try {
            for (var setB_1 = __values(setB), setB_1_1 = setB_1.next(); !setB_1_1.done; setB_1_1 = setB_1.next()) {
                var elem = setB_1_1.value;
                difference.delete(elem);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (setB_1_1 && !setB_1_1.done && (_a = setB_1.return)) _a.call(setB_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return difference;
    }

    /**
     * Returns a new set that contains the elements that are in both `setA` and `setB`. Taken from https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Set.
     *
     * ```ts
     * const setA = new Set([1, 2, 3, 4]);
     * const setB = new Set([3, 4, 5, 6]);
     * setIntersection(setA, setB); // Set [3, 4]
     * ```
     */
    function setIntersection(setA, setB) {
        var e_1, _a;
        var intersection = new Set();
        try {
            for (var setB_1 = __values(setB), setB_1_1 = setB_1.next(); !setB_1_1.done; setB_1_1 = setB_1.next()) {
                var elem = setB_1_1.value;
                if (setA.has(elem)) {
                    intersection.add(elem);
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (setB_1_1 && !setB_1_1.done && (_a = setB_1.return)) _a.call(setB_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return intersection;
    }

    /**
     * Returns a new set that contains the elements that are in either `setA` or `setB`. Taken from https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Set.
     *
     * ```ts
     * const setA = new Set([1, 2, 3, 4]);
     * const setB = new Set([3, 4, 5, 6]);
     * setUnion(setA, setB); // Set [1, 2, 3, 4, 5, 6]
     * ```
     */
    function setUnion(setA, setB) {
        var e_1, _a;
        var union = new Set(setA);
        try {
            for (var setB_1 = __values(setB), setB_1_1 = setB_1.next(); !setB_1_1.done; setB_1_1 = setB_1.next()) {
                var elem = setB_1_1.value;
                if (!setA.has(elem)) {
                    union.add(elem);
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (setB_1_1 && !setB_1_1.done && (_a = setB_1.return)) _a.call(setB_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return union;
    }

    /**
     * Returns a new set that contains the elements that are in only one of the two sets. Taken from https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Set.
     *
     * ```ts
     * const setA = new Set([1, 2, 3, 4]);
     * const setB = new Set([3, 4, 5, 6]);
     * symmetricSetDifference(setA, setB); // Set [1, 2, 5, 6]
     * ```
     */
    function symmetricSetDifference(setA, setB) {
        var e_1, _a;
        var difference = new Set(setA);
        try {
            for (var setB_1 = __values(setB), setB_1_1 = setB_1.next(); !setB_1_1.done; setB_1_1 = setB_1.next()) {
                var elem = setB_1_1.value;
                if (difference.has(elem)) {
                    difference.delete(elem);
                }
                else {
                    difference.add(elem);
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (setB_1_1 && !setB_1_1.done && (_a = setB_1.return)) _a.call(setB_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return difference;
    }

    /**
     * Like a standard debounce from e.g. `micro-dash`, but can execute a different function for a different wait period at each invocation.
     *
     * ```ts
     * const print = (value) => console.log(value);
     * const debouncer = new Debouncer();
     *
     * debouncer.run(print, 1000, 1);
     * await sleep(500);
     *
     * debouncer.run(print, 1000, 2);
     * await sleep(1000); // prints "2"
     *
     * debouncer.run(print, 0, 3);
     * debouncer.run(print, 1000, 4);
     * await sleep(500);
     *
     * debouncer.run(print, 2000, 5);
     * debouncer.run(print, 50, 6);
     * await sleep(50); // prints "6"
     * ```
     */
    var Debouncer = /** @class */ (function () {
        function Debouncer() {
        }
        Debouncer.prototype.run = function (func, wait) {
            if (wait === void 0) { wait = 0; }
            var args = [];
            for (var _i = 2; _i < arguments.length; _i++) {
                args[_i - 2] = arguments[_i];
            }
            this.cancel();
            this.timeoutId = setTimeout.apply(void 0, __spread([func, wait], args));
        };
        Debouncer.prototype.cancel = function () {
            if (this.timeoutId !== undefined) {
                clearTimeout(this.timeoutId);
            }
        };
        return Debouncer;
    }());

    /**
     * Returns a new function to use in place of `func` that will call the provided hooks in addition to `func`. They are called in the following order:
     *
     * 1. `before`
     * 2. `around` if provided, else `original`
     * 3. `transform`
     * 4. `after`
     *
     * ```ts
     * const sum = (a: number, b: number) => a + b;
     * const sumAndLog = wrapFunction(sum, {
     *   after: (result, a, b) => {
     *     console.log(a, '+', b, '=', result);
     *   },
     * }
     * const sumPlusOne = wrapFunction(sum, {
     *   transform: (result) => result + 1,
     * });
     * ```
     */
    function wrapFunction(original, hooks) {
        var wrapped = function () {
            var _a;
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            var result;
            callHook(hooks.before, this, args);
            if (hooks.around) {
                result = (_a = hooks.around).call.apply(_a, __spread([this, original], args));
            }
            else {
                result = original.apply(this, args);
            }
            result = callHook(hooks.transform, this, __spread([result], args), result);
            callHook(hooks.after, this, __spread([result], args));
            return result;
        };
        Object.defineProperty(wrapped, "length", { value: original.length });
        return wrapped;
    }
    /** @hidden */
    function callHook(hook, context, args, defaultResult) {
        return hook ? hook.apply(context, args) : defaultResult;
    }

    /**
     * An object you can use to create a promise and resolve/reject it later.
     *
     * ```ts
     * const deferred = new Deferred<string>();
     *
     * // later
     * deferred.resolve('a nice value'); // causes `deferred.promise` to resolve
     *
     * // or
     * deferred.reject('a bad value'); // causes `deferred.promise` to reject
     * ```
     */
    var Deferred = /** @class */ (function () {
        function Deferred() {
            var _this = this;
            this.pending = true;
            var hooks = {
                before: function () {
                    _this.pending = false;
                },
            };
            this.promise = new Promise(function (resolve, reject) {
                _this.resolve = wrapFunction(resolve, hooks);
                _this.reject = wrapFunction(reject, hooks);
            });
        }
        Deferred.prototype.isPending = function () {
            return this.pending;
        };
        return Deferred;
    }());

    /**
     * Returns a promise that resolves after `ms` milliseconds.
     *
     * ```ts
     * // do something
     * await sleep(1000); // wait a second
     * // do something else
     * ```
     */
    function sleep(ms) {
        return new Promise(function (resolve) {
            setTimeout(resolve, ms);
        });
    }

    function mapToObject(collection, iteratee) {
        return microDash.transform(collection, function (accumulator, origValue, keyOrIndex) {
            var _a = __read(iteratee(origValue, keyOrIndex), 2), key = _a[0], newValue = _a[1];
            accumulator[key] = newValue;
        });
    }

    function mapAsKeys(collection, iteratee) {
        return mapToObject(collection, function (value, keyOrIndex) { return [
            value,
            iteratee(value, keyOrIndex),
        ]; });
    }

    /**
     * Rounds `value` to the nearest multiple of `multiple`.
     *
     * ```ts
     * roundToMultiple(5, 13); // 15
     * roundToMultiple(2, 4.8); // 4
     * roundToMultiple(3, -4); // -3
     * roundToMultiple(0.5, 1.6); // 1.5
     * ```
     */
    function roundToMultipleOf(multiple, value) {
        return Math.round(value / multiple) * multiple;
    }

    /**
     * Defines the canonical string representation for each time unit. Many aliases
     * can also be used with the functions that deal with time units:
     *
     * - ns, Nanosecond, Nanoseconds, nanosecond, nanoseconds, nanos
     * - μs, Microsecond, Microseconds, microsecond, microseconds, micros
     * - ms, Millisecond, Milliseconds, millisecond, milliseconds, millis
     * - s, Second, Seconds, second, seconds, S, sec, sec, secs
     * - m, Minute, Minutes, minute, minutes, M, min, mins
     * - h, Hour, Hours, hour, hours, H, hr, hrs
     * - d, Day, Days, day, days, D
     * - w, Week, Weeks, week, weeks, W, wk, wks
     * - y, Year, Years, year, years, Y, yr, yrs
     * - dec, Decade, Decades, decade, decades
     * - cent, Century, Centuries, century, centuries
     * - mil, Millennium, Millennia, millennium, millennia
     */

    (function (TimeUnit) {
        TimeUnit["Nanoseconds"] = "ns";
        TimeUnit["Microseconds"] = "\u03BCs";
        TimeUnit["Milliseconds"] = "ms";
        TimeUnit["Seconds"] = "s";
        TimeUnit["Minutes"] = "m";
        TimeUnit["Hours"] = "h";
        TimeUnit["Days"] = "d";
        TimeUnit["Weeks"] = "w";
        TimeUnit["Years"] = "y";
        TimeUnit["Decades"] = "dec";
        TimeUnit["Centuries"] = "cent";
        TimeUnit["Millennia"] = "mil";
    })(exports.TimeUnit || (exports.TimeUnit = {}));
    /** @hidden */
    var nanoConversions = __assign(__assign(__assign(__assign(__assign(__assign(__assign(__assign(__assign(__assign(__assign(__assign({}, getNanoConversions(exports.TimeUnit.Nanoseconds, "Nanosecond", 1, {
        aliases: ["nanos"],
    })), getNanoConversions(exports.TimeUnit.Microseconds, "Microsecond", 1000, {
        aliases: ["micros"],
    })), getNanoConversions(exports.TimeUnit.Milliseconds, "Millisecond", 1000 * 1000, {
        aliases: ["millis"],
    })), getNanoConversions(exports.TimeUnit.Seconds, "Second", 1000 * 1000 * 1000, {
        aliases: ["S", "sec", "secs"],
    })), getNanoConversions(exports.TimeUnit.Minutes, "Minute", 60 * 1000 * 1000 * 1000, {
        aliases: ["M", "min", "mins"],
    })), getNanoConversions(exports.TimeUnit.Hours, "Hour", 60 * 60 * 1000 * 1000 * 1000, {
        aliases: ["H", "hr", "hrs"],
    })), getNanoConversions(exports.TimeUnit.Days, "Day", 24 * 60 * 60 * 1000 * 1000 * 1000, {
        aliases: ["D"],
    })), getNanoConversions(exports.TimeUnit.Weeks, "Week", 7 * 24 * 60 * 60 * 1000 * 1000 * 1000, {
        aliases: ["W", "wk", "wks"],
    })), getNanoConversions(exports.TimeUnit.Years, "Year", 365 * 24 * 60 * 60 * 1000 * 1000 * 1000, {
        aliases: ["Y", "yr", "yrs"],
    })), getNanoConversions(exports.TimeUnit.Decades, "Decade", 10 * 365 * 24 * 60 * 60 * 1000 * 1000 * 1000)), getNanoConversions(exports.TimeUnit.Centuries, "Century", 100 * 365 * 24 * 60 * 60 * 1000 * 1000 * 1000, { plural: "Centuries" })), getNanoConversions(exports.TimeUnit.Millennia, "Millennium", 1000 * 365 * 24 * 60 * 60 * 1000 * 1000 * 1000, { plural: "Millennia" }));
    /**
     * Converts time between two units. Units can be any value described in the docs for [[TimeUnit]].
     *
     * ```ts
     * convertTime(1, 's', 'ms'); // 1000
     * convertTime(20, TimeUnit.Decades, TimeUnit.Centuries); // 2
     * ```
     */
    function convertTime(value, unit, targetUnit) {
        return (value * nanoConversions[unit]) / nanoConversions[targetUnit];
    }
    /**
     * Constructs a string representation of an elapsed amount of time. The least significant unit will be rounded to the nearest whole number.
     *
     * ```ts
     * elapsedToString(2001, ["s", "ms"]); // "2 s 1 ms"
     * elapsedToString(15, ["wks", "d"], ( elapsedUnit: TimeUnit.Days }); // "2 wks 1 d"
     * elapsedToString(1, [TimeUnit.Microseconds]); // "1000 μs"
     * ```
     *
     * @param showLeadingZeros whether to include the most significant units in the string if they are zero.
     */
    function elapsedToString(elapsed, units, _a) {
        var _b = _a === void 0 ? {} : _a, _c = _b.elapsedUnit, elapsedUnit = _c === void 0 ? exports.TimeUnit.Milliseconds : _c, _d = _b.showLeadingZeros, showLeadingZeros = _d === void 0 ? true : _d;
        elapsed = roundToMultipleOf(convertTime(1, microDash.last(units), elapsedUnit), elapsed);
        var showZeros = showLeadingZeros;
        var tokens = [];
        units.forEach(function (unit, i) {
            var conversion = convertTime(1, elapsedUnit, unit);
            var value = Math.floor(elapsed * conversion);
            if (value > 0 || showZeros || i === units.length - 1) {
                tokens.push(value, unit);
                showZeros = true;
            }
            elapsed -= value / conversion;
        });
        return tokens.join(" ");
    }
    /** @hidden */
    function getNanoConversions(unit, singular, nanos, _a) {
        var _b = _a === void 0 ? {} : _a, _c = _b.aliases, aliases = _c === void 0 ? [] : _c, _d = _b.plural, plural = _d === void 0 ? singular + "s" : _d;
        return mapAsKeys(__spread([
            unit,
            singular,
            singular.toLowerCase(),
            plural,
            plural.toLowerCase()
        ], aliases), function () { return nanos; });
    }

    /**
     * Throws an error if `condition` is falsy, and acts as a type guard.
     *
     * @param message The message to set in the error that is thrown
     *
     * ```ts
     * class ProblemLogger {
     *   problem?: string;
     *
     *   log() {
     *     assert(this.problem, "You must set problem before logging it");
     *
     *     // now typescript knows `this.problem` is truthy, so we can safely call methods on it
     *     console.log(problem.toUpperCase());
     *   }
     * }
     * ```
     */
    function assert(condition, message) {
        if (!condition) {
            throw new Error(message);
        }
    }

    /**
     * Extend this for classes whose objects are directly callable.
     *
     * ```ts
     * class Multiplier extends CallableObject<(value: number) => number> {
     *   constructor(public factor: number) {
     *     super((value: number) => value * this.factor);
     *   }
     * }
     *
     * const doubler = new Multiplier(2);
     * doubler(2); // 4
     * doubler.factor = 3;
     * doubler(2); // 6
     * ```
     */
    var CallableObject = /** @class */ (function () {
        function CallableObject(callAction) {
            var _newTarget = this.constructor;
            return Object.setPrototypeOf(callAction, _newTarget.prototype);
        }
        return CallableObject;
    }());

    /** @hidden */
    var seq = 0;
    /**
     * Creates a factory function for building objects of a given type. Commonly used to create test objects for use in specs.
     *
     * ```ts
     * interface Message {
     *   id: number;
     *   text: string;
     * }
     *
     * interface Options {
     *   cypherDistance: number;
     * }
     *
     * declare function shiftCharacters(text: string, distance: number): string;
     *
     * const buildMessage = createBuilder<Message, Options>(
     *   (seq) => ({ id: seq, text: `message ${seq}` }),
     *   (message, _seq, options) => {
     *     message.text = shiftCharacters(message.text, options.cypherDistance || 0);
     *   },
     * );
     *
     * buildMessage(); // { id: 1, text: "message 1" }
     * buildMessage({ text: "Hello world!" }); // { id: 2, text: "Hello world!" }
     * buildMessage({ text: "abc" }, { cypherDistance: 3 }); // { id: 3, text: "def" }
     * ```
     */
    function createBuilder(buildDefaults, afterBuild) {
        return function (attributes, options) {
            if (options === void 0) { options = {}; }
            ++seq;
            var obj = Object.assign(buildDefaults(seq, options), attributes);
            if (afterBuild) {
                afterBuild(obj, seq, options);
            }
            return obj;
        };
    }

    /**
     * Checks if `value` is anything other than `undefined`.
     *
     * ```ts
     * isDefined({ a: 1 }); // true
     * isDefined(false); // true
     * isDefined(null); // true
     * isDefined(undefined); // false
     * ```
     */
    function isDefined(value) {
        return !microDash.isUndefined(value);
    }

    /**
     * Performs a deep comparison between two values to determine if they are equivalent, up to the given depth. Once that depth is reached, remaining values are compared using `Object.is()`.
     *
     * ```ts
     * let object1 = "a";
     * let object2 = "a";
     * isEqualAtDepth(0, object1, object2); // true
     * isEqualAtDepth(1, object1, object2); // true
     *
     * let object1 = { a: 1 };
     * let object2 = { a: 1 };
     * isEqualAtDepth(0, object1, object2); // false
     * isEqualAtDepth(1, object1, object2); // true
     *
     * object1 = { a: [1, 2, 3], d: { e: 1 } };
     * object2 = { a: [1, 2, 3], d: { e: 1 } };
     * isEqualAtDepth(0, object1, object2); // false
     * isEqualAtDepth(1, object1, object2); // false
     * isEqualAtDepth(2, object1, object2); // true
     * isEqualAtDepth(3, object1, object2); // true
     * ```
     */
    function isEqualAtDepth(depth, value, other) {
        if (Object.is(value, other)) {
            // covers e.g. NaN === NaN
            return true;
        }
        if (depth === 0 || !(value instanceof Object && other instanceof Object)) {
            return false;
        }
        return hasSameValues(depth, value, other);
    }
    /** @hidden */
    function hasSameValues(depth, value, other) {
        var e_1, _a, e_2, _b;
        try {
            for (var _c = __values(microDash.keys(value)), _d = _c.next(); !_d.done; _d = _c.next()) {
                var key = _d.value;
                if (!other.hasOwnProperty(key)) {
                    return false;
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
            }
            finally { if (e_1) throw e_1.error; }
        }
        try {
            for (var _e = __values(microDash.keys(other)), _f = _e.next(); !_f.done; _f = _e.next()) {
                var key = _f.value;
                if (!isEqualAtDepth(depth - 1, value[key], other[key])) {
                    return false;
                }
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (_f && !_f.done && (_b = _e.return)) _b.call(_e);
            }
            finally { if (e_2) throw e_2.error; }
        }
        return true;
    }

    /**
     * Converts a 2D array to a csv string. Values are converted using micro-dash's toString().
     *
     * ```ts
     * toCsv([["a", "b", "c"], ["d", "e", "f"], ["g", "h", "i"]]); // "a,b,c\nd,e,f\ng,h,i"
     * toCsv([
     *   ["a", "", "string"]
     *   [undefined, null],
     *   [true, false],
     *   [1, 2, 3],
     *   [{}, { hi: "there" }]
     * ]) // "a,,string\n,\ntrue,false\n1,2,3\n[object Object],[object Object]"
     * ```
     */
    function toCsv(content) {
        return content
            .map(function (row) { return row.map(function (cell) { return toCellString(cell); }).join(","); })
            .join("\n");
    }
    /** @hidden */
    var specialCsvCharactersRegexp = /["|,|\n|\r]/;
    /** @hidden */
    var allDoubleQuotes = /"/g;
    /** @hidden */
    function toCellString(value) {
        var str = microDash.toString(value);
        if (specialCsvCharactersRegexp.test(str)) {
            return "\"" + str.replace(allDoubleQuotes, "\"\"") + "\"";
        }
        else {
            return str;
        }
    }

    /**
     * Replaces a method on `object` with a wrapped version that will call the provided hooks in addition to the original method. See `wrapFunction()` for more details on the hooks.
     *
     * @returns a function to reset the method to its previous, unwrapped state
     *
     * ```ts
     * // log all get requests to the console
     * wrapMethod(HttpClient.prototype, "get", {
     *   before(url) {
     *     console.log("Sending GET request to", url);
     *   }
     * });
     *
     * // suppress benign error messages
     * const unwrap = wrapMethod(console, "error", {
     *   around(original, ...args) {
     *     if (args[0].message !== 'something benign') {
     *       original(...args);
     *     }
     *   }
     * });
     *
     * // remove error suppression (from above)
     * unwrap();
     * ```
     */
    function wrapMethod(object, key, hooks) {
        var original = object[key];
        object[key] = wrapFunction(original, hooks);
        return function () {
            object[key] = original;
        };
    }

    exports.CallableObject = CallableObject;
    exports.Debouncer = Debouncer;
    exports.Deferred = Deferred;
    exports.assert = assert;
    exports.convertTime = convertTime;
    exports.createBuilder = createBuilder;
    exports.elapsedToString = elapsedToString;
    exports.isDefined = isDefined;
    exports.isEqualAtDepth = isEqualAtDepth;
    exports.isSetEqual = isSetEqual;
    exports.isSuperset = isSuperset;
    exports.mapAsKeys = mapAsKeys;
    exports.mapToObject = mapToObject;
    exports.roundToMultipleOf = roundToMultipleOf;
    exports.setDifference = setDifference;
    exports.setIntersection = setIntersection;
    exports.setUnion = setUnion;
    exports.sleep = sleep;
    exports.symmetricSetDifference = symmetricSetDifference;
    exports.toCsv = toCsv;
    exports.wrapFunction = wrapFunction;
    exports.wrapMethod = wrapMethod;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=s-js-utils.umd.js.map
